﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace cegesauto
{
     class Program
    {
        private static List<Auto> autok = new List<Auto>();
        private static List<Nap> napok = new List<Nap>();
        private static List<Berles> berlesek = new List<Berles>();

        static void Main(string[] args)
        {
            Beolvasas("autok.txt");

            

            Console.WriteLine("2. feladat");
            Masodik();
            Console.WriteLine();

            berlesek.Sort();
            Console.WriteLine("3. feladat");
            Harmadik();
            Console.WriteLine();

            Console.WriteLine("4. feladat");
            Negyedik();
            Console.WriteLine();

            Console.WriteLine("5. feladat");
            //Otodik();
            Console.WriteLine();

            Console.WriteLine("7. feladat");
            Hetedik();
            Console.WriteLine();


            Console.ReadKey();


        }


        #region Beolvasas
        private static void Beolvasas(string path)
        {
            var lines = File.ReadAllLines(path);

            int counter = 1;
            foreach (var line in lines)
            {
                var adatok = line.Split();

                //napsorszam
                int napSorszam = int.Parse(adatok[0]);

                //ora:perc
                string idopontString = adatok[1];
                int idopont = TimeToInt(adatok[1]);

                //rendszam
                string rendszam = adatok[2];

                //dolgozo
                int dolgozoID = int.Parse(adatok[3]);

                //kmAllas
                int kmAllas = int.Parse(adatok[4]);

                //kihajtasE
                bool kihajtasE = BoolParser(adatok[5]);

                Auto ujAuto = new Auto(rendszam, kmAllas,0);

                if (autok.Count == 0 || autok.Contains(ujAuto))
                {
                    autok.Add(ujAuto);
                }
               

                Berles ujBerles = new Berles(counter, dolgozoID, napSorszam, idopont, idopontString, kihajtasE, ujAuto);

                berlesek.Add(ujBerles);
                
            }
        }
        #endregion

        #region napokSetter
        private static void NapokSetter()
        {
            
            foreach (var berles in berlesek)
            {
                List<Berles> berlesek = new List<Berles>();
                if (napok.Count == 0)
                {
                    berlesek.Add(berles);
                    napok.Add(new Nap(berlesek,berles.napSzam));
                }
                else
                {
                    foreach (var nap in napok)
                    {
                        if (nap.Sorszam == berles.napSzam)
                        {
                            nap.berlesek.Add(berles);
                        }
                        else
                        {
                            berlesek.Add(berles);
                            napok.Add(new Nap(berlesek, berles.napSzam));
                        }
                    }
                }
            }
        }
        #endregion


        #region 2. feladat
        private static void Masodik()
        {
            List<Berles> kivettAutok = new List<Berles>();
            foreach (var berles in berlesek)
            {
                if (berles.KihajtE)
                {
                    if (!kivettAutok.Contains(berles))
                    {
                        kivettAutok.Add(berles);
                    }
                }
            }
            kivettAutok.Sort();
            Console.WriteLine($"{kivettAutok[kivettAutok.Count-1].napSzam} nap rendszam: {kivettAutok[kivettAutok.Count - 1].Berlemeny.Rendszam} ");
        }
        #endregion


        #region 3. feladat
        private static void Harmadik()
        {
            Console.WriteLine("Nap:");
            int nap = int.Parse(Console.ReadLine());
            foreach (var berles in berlesek)
            {
                if (berles.napSzam == nap)
                {
                    Console.WriteLine($"{berles.IdopontString} {berles.Berlemeny.Rendszam} {berles.SzemelyID} {BoolToString(berles.KihajtE)}");
                }
            }
        }
        #endregion
        #region 4. feladat
        private static void Negyedik()
        {
            
            int countki = 0;
            int countbe = 0;
            foreach (var berles in berlesek)
            {
                if (berles.KihajtE)
                {
                    countki++;
                    
                }
                else
                {
                    countbe++;
                    
                }
            }

            

            Console.WriteLine($"A feladat végén {countki - countbe} autót nem hoztak vissza.");
        }
        #endregion
        #region 5. feladat
        private static void Otodik()
        {
            foreach (var berles in berlesek)
            {
                Console.WriteLine($"{berles.Berlemeny.Rendszam} {berles.Berlemeny.megtettKm} km");
            }
        }
        #endregion

        #region 7. feladat

        private static void Hetedik()
        {
            Console.WriteLine("Rendszám:");
            string rendszam = Console.ReadLine();
            string kihajt =  "";
            string behajt = "";
            int kihajtKM = 0;
            int behajtKM = 0;
            foreach (var berles in berlesek)
            {
                using (StreamWriter sw = new StreamWriter($"{rendszam}_menetlevel.txt"))
                {
                    if (berles.Berlemeny.Rendszam == rendszam)
                    {
                        if (berles.KihajtE)
                        {
                            kihajt = $"{berles.SzemelyID}\t{berles.IdopontString}\t{berles.Berlemeny.kmSzamlalo} km\t";
                            kihajtKM = berles.Berlemeny.kmSzamlalo;
                        }
                        else
                        {
                            behajtKM = berles.Berlemeny.kmSzamlalo;
                            behajt = $"{berles.SzemelyID}\t{berles.IdopontString}\t{berles.Berlemeny.kmSzamlalo} km\t";
                        }
                        if (kihajt != "" && behajt != "")
                        {
                            sw.WriteLine(behajt + kihajt);
                            berles.megtettKm = behajtKM - kihajtKM;
                            kihajt = ""; 
                            behajt = "";
                            kihajtKM = 0;
                            behajtKM = 0;
                        }
                    }
                }
                
            }
        }
        #endregion

        #region Helpers
        private static int TimeToInt(string idopont)
        {
            var adatok = idopont.Split(':');
            int orak = int.Parse(adatok[0]) * 60;
            int percek = int.Parse(adatok[1]);


            return orak + percek;
        }

        private static bool BoolParser(string input)
        {
            switch (input)
            {
                case "0":
                    return true;
                    break;
                case "1":
                    return false;
                    break;
                default:
                    //felesleges
                    return false;
                    break;
            }
        }
        private static string BoolToString(bool ertek)
        {
            if (ertek)
            {
                return "ki";
            }
            else return "be";
        }

        #endregion
    }


}
